Subject: Re: bug#34214: 25.3; minibuffer function help in lisp modes changes match-data

From: Stefan Kangas <[email-masked]>
Date: Thu, 13 Aug 2020 07:30:35 -0700

[Please use "Reply to all" so that your replies get recorded in the bug
 tracker.]

"Miguel V. S. Frasson" <[email-masked]> writes:

> Hi.
>
> The "documented" behavior is in Elisp Reference, but not in doc-strings of
> functions that rely on match data. So they are not so easily spotted by
> non-experienced users.
>
> This bug teached me a lesson, but it took me a lot of time to realize how
> volatile match-data is, changed even by a helper mode like eldoc.
>
> IMO it is so easy to avoid interference into user experience in this case,
> adding convenience, just by saving match data inside eldoc...
>
> Should a helper mode "confuse" non-experienced users because it could rely
> on "documented" behavior? If so, why does Emacs have disabled commands, if
> they are also documented?
>
> Best regards
>
> Miguel

Actually, you may have a point regarding eldoc, if it's clobbering match
data just by moving around the buffer.  I guess it would be nice to
avoid that.

Let's see if anyone else has something to say here.

Best regards,
Stefan Kangas